
        include tvcstart.asm
        include tvcconst.asm
        include tvckeys.asm

xk:     equ 64
yk:     equ 64
vaddr:  equ 8000h+(56*64)+16
x:      equ 64
dr:     equ 2
border: equ 0
szpage: equ 0f9h
p1:     equ 0fch
BORDERPORT: equ 0

START:
        di
        ld  a,P0U0+P1U1+P2VID+P3SYS ;VID a LAP2-re
        out (2),a

        call sztabl

main00: di
        ld  a,P0U0+P1U1+P2VID+P3SYS ;VID a LAP2-re
        out (2),a

main0:  ld hl,fdats
        ld a,(hl)
        inc a
        jr nz,main1
        ld hl,fdats
main1:  inc hl
        inc hl
        inc hl
        ld a,(hl)
        ld (da+1),a
        inc hl
        ld a,(hl)
        ld (dg+1),a
        inc hl
        xor a
        sub (hl)
        ld (db+1),a
        inc hl
        ld a,80h
        ld (alfa),a
        xor a
        ld (beta),a
        ld a,0c0h
        ld (gamma),a
        ld a,(hl)       ;Pontok szama
        ld (pnum+1),a
        inc hl
        ld (koord3+2),hl;Pontok adatai
        ld c,a
        ld b,0
        add hl,bc
        add hl,bc
        add hl,bc
        ld (rajzol+3),hl;Vonalak adatai
main2:  ld a,(hl)
        inc hl
        inc a
        jp nz,main2
        ld (main0+1),hl ;Kovetkezo alakzat
        call calc
        call rajzol
        call clear
        call rajzol
main:
        di
        ld  a,P0U0+P1U1+P2VID+P3SYS ;VID a LAP2-re
        out (2),a

        call keys
;        ld a,3	;border     ;144
;        out (BORDERPORT),a
        call clear
;        ld a,10	;border     ;144
;        out (BORDERPORT),a
        call calc
;        ld a,15	;border     ;73
;        out (BORDERPORT),a
        call rajzol
;        ld a,0
;        out (BORDERPORT),a

        ld  a,P0U0+P1U1+P2U2+P3SYS ;eredeti lapozas
        out (2),a
        ei
;        halt
        call TVCKEYS_READKEY
        or a
        jr z,main
        jp main00

        ;itt kellene visszalepni a rendszerbe...
        di     ;de mi inkabb
        halt   ;leallunk

keys:   ld a,4
;        out (0b5h),a
;        in a,(0b5h)
        ld b,a
        ld a,(alfa)
        rl b
da:     add a,0
noameg: rl b
        ld (alfa),a
        rl b
        jp c,normeg
        ld a,(sugar)
        add a,dr
        cp 3bh
        jp nc,normeg
        ld (sugar),a
normeg: ld a,(gamma)
        rl b
dg:     add a,0
nogmeg: rl b
nogmin: ld (gamma),a
        rl b
        ld a,(beta)
db:     add a,0
        ld (beta),a
nobmeg: rl b
        jp c,normin
        ld a,(sugar)
        sub dr
        cp dr
        jp c,normin
        ld (sugar),a
normin: rl b
nobmin: ld a,1
        or a
        ret
clear:  di
        ld (cstack+1),sp
caddr:  ld sp,8000h+(192*64)+48     ;4k hosszu kepernyo (128x128)
        ld de,0
        ld b,128
clear0: push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        push de
        ld hl,0-32  ;sor elejet es veget atlepjuk
        add hl,sp
        ld sp,hl
        djnz clear0
cstack: ld sp,0
        ret
calc:   ld a,szpage             ;szorzotabla szegmense
;        out (0b1h),a
        ld a,(sugar)
        ld (r0+1),a
        ld (r1+1),a
        ld (r2+1),a
        ld (r3+1),a
        ld (r4+1),a
        ld (r5+1),a

        ld b,0

        ld hl,stabl
        ld a,(alfa)
        ld c,a
        add hl,bc
        ld a,(hl)
        ld (sa1+1),a
        xor 80h
        ld (sa0+1),a
        ld hl,stabl+64
        add hl,bc
        ld a,(hl)
        ld (ca0+1),a
        xor 80h
        ld (ca1+1),a
        ld (ca2+1),a

        ld hl,stabl
        ld a,(beta)
        ld c,a
        add hl,bc
        ld a,(hl)
        ld (sb0+1),a
        ld (sb1+1),a
        ld (sb2+1),a
        ld hl,stabl+64
        add hl,bc
        ld a,(hl)
        ld (cb0+1),a
        ld (cb1+1),a
        ld (cb2+1),a

        ld hl,stabl
        ld a,(gamma)
        ld c,a
        add hl,bc
        ld a,(hl)
        ld (sg0+1),a
        ld (sg1+1),a
        ld (sg2+1),a
        ld hl,stabl+64
        add hl,bc
        ld a,(hl)
        ld (cg0+1),a
        ld (cg1+1),a
        ld (cg2+1),a

ca0:    ld b,0
cb0:    ld c,0
        call szoroz
        ld b,a
r0:     ld c,0
        call szoroz
        ld (x1+1),a

sa0:    ld b,0          ;X2 szamitasa
cg0:    ld c,0
        call szoroz
        ld (x20+1),a
ca1:    ld b,0
sb0:    ld c,0
        call szoroz
        ld b,a
sg0:    ld c,0
        call szoroz
        ld b,a
x20:    ld c,0
        call plusz
        ld b,a
r1:     ld c,0
        call szoroz
        ld (x2+1),a

sa1:    ld b,0          ;X3 szamitasa
sg1:    ld c,0
        call szoroz
        ld (x30+1),a
ca2:    ld b,0
sb1:    ld c,0
        call szoroz
        ld b,a
cg1:    ld c,0
        call szoroz
        ld b,a
x30:    ld c,0
        call plusz
        ld b,a
r2:     ld c,0
        call szoroz
        ld (x3+1),a

r3:     ld b,0          ;Y1 szamitasa
sb2:    ld c,0
        call szoroz
        ld (y1+1),a

cb1:    ld b,0          ;Y2 szamitasa
sg2:    ld c,0
        call szoroz
        ld b,a
r4:     ld c,0
        call szoroz
        ld (y2+1),a

cb2:    ld b,0          ;Y3 szamitasa
cg2:    ld c,0
        call szoroz
        ld b,a
r5:     ld c,0
        call szoroz
        ld (y3+1),a

koord3: ld ix,0         ;3d koordinatak
        ld iy,k2        ;2d koordinatak
pnum:   ld b,0          ;pontok szama
calc0:  push bc

        ld b,(ix+0)     ;X koordinata szamolasa
x1:     ld c,0
        call szoroz
        ld b,a
        ld c,xk
        call plusz
        ld (calc1+1),a
        ld b,(ix+1)
x2:     ld c,0
        call szoroz
        ld b,a
calc1:  ld c,0
        call plusz
        ld (calc2+1),a
        ld b,(ix+2)
x3:     ld c,0
        call szoroz
        ld b,a
calc2:  ld c,0
        call plusz
        ld (iy+0),a

        ld b,(ix+0)     ;Y koordinata szamitas
y1:     ld c,0
        call szoroz
        ld b,a
        ld c,yk
        call plusz
        ld (calc3+1),a
        ld b,(ix+1)
y2:     ld c,0
        call szoroz
        ld b,a
calc3:  ld c,0
        call plusz
        ld (calc4+1),a
        ld b,(ix+2)
y3:     ld c,0
        call szoroz
        ld b,a
calc4:  ld c,0
        call plusz
        ld (iy+1),a
        inc ix          ;kov. adatokra lepes
        inc ix
        inc ix
        inc iy
        inc iy
        pop bc
        djnz calc0
        ld a,p1         ;Allando P1
;        out (0b1h),a
        ret
rajzol: di  ; DRAW hasznalja SP-t!
        ld ix,0
rajzol0:ld hl,k2
        ld b,0
        ld a,(ix)
        ld c,a
        inc a
        jr z,rajzend
        add hl,bc
        add hl,bc
        ld e,(hl)
        inc hl
        ld d,(hl)
        ld hl,k2
        ld c,(ix+1)
        add hl,bc
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        call draw
        inc ix
        inc ix
        jr rajzol0
rajzend:ld a,(4025h)    ;kepvaltas
;        add a,50h
;        ld (caddr+2),a
;        sub 10h
;        ld (daddr+2),a
;        sub 40h
;        xor 30h
;        ld (4025h),a
;        ei
        ret

sztabl: ld a,szpage             ;Szorzotabla felepitese
;        out (0b1h),a
        ld de,4000h
        ld c,128
sztabl0:ld hl,0
        ld a,128
        sub c
        ld (sztabl2+1),a
        ld b,128
sztabl1:push hl
        ld a,h
        rl l
        rla
        ld (de),a
        inc de
        pop hl
        ld a,l
sztabl2:add a,0
        ld l,a
        ld a,h
        adc a,0
        ld h,a
        djnz sztabl1
        dec c
        jp nz,sztabl0
        ret

szoroz: ld d,a                  ;A=B*C
        ld a,b
        xor c
        and 80h
        ld e,a                  ;E=elojel
        xor a
        res 7,c
        set 7,b                 ;P1 cim (tablazat helye)
        rr b
        rra
        or c
        ld c,a
        ld a,(bc)               ;Szorzat (tablazatbol)
        or e                    ;Elojel
        ret

plusz:  ld de,0                 ;A=B+C
        rl b
        rr e                    ;E-be egyik elojel
        rl c
        rr d                    ;D-be masik elojel
        ld a,e
        xor d
        jp nz,kivonas           ;Kulonbozo elojelnel kivonas
        ld a,b
        add a,c
        rra
        or e
        ret
kivonas:ld a,b                  ;Nagyobb-kisebb
        sub c
        jr nc,bnagy             ;Ugras ha ez pozitiv
        ld a,c
        sub b                   ;Egyebkent ellenkezo kivonas es
        ld e,d                  ;    a nagyobbe az elojel
bnagy:  rra
        or e
        ret


draw:   LD (dstack+1),SP        ;HIRES 4 szinu vonalhuzo
        LD A,D                  ; 1.szinnel huz vonalat
        SUB H
        JR NC,D0
        NEG
        EX DE,HL        ;HL a kisebb X koordinataju pont
D0:     LD D,A          ;X elteres
        ld a,h
        and 3
        ld b,a
        add a,a
        add a,a
        add a,b
        ld c,a
        add a,a
        ld b,a          ;B=10*X; C=5*X;  X csak 0..3 !!!
        LD SP,x
        LD A,E
        SUB L
        JR NC,D1
        NEG
        LD SP,0-x
D1:     CP D            ;X es  Y elteres osszehasonlitasa
        LD E,A
        JR C,D2         ;A nagyobb szerint megyunk (D=nagyobb,E=kisebb)
        LD A,E          ;Y elteres nagyobb:
        LD E,D          ; -csere
        LD D,A          ; -cim=s72+20*X
        INC D           ; -elteres novelese
        ld a,b
        add a,a
        ld bc,s72
        jr d3
D2:     ld a,b          ;X elteres nagyobb:
        add a,c         ; -cim=s7+15*X
        ld bc,s7
d3:     add a,c         ;cim beirasa
        ld (d5+1),a
        ld a,b
        adc a,0
        ld (d5+2),a
        LD A,D
        OR A
        JP NZ,D30       ;Egy pont, ha a nagyobb elteres 0
        LD D,1
D30:    LD A,H
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        add hl,hl
        add hl,hl
        add hl,hl       ;HL = 64x
daddr:  LD BC,vaddr
        ADD HL,BC
        LD B,0
        LD C,A
        SRL C
        SRL C
        ADD HL,BC
D4:     LD A,D          ;nagyobb elteres
        SRL A
        NEG
        LD B,D          ;nagyobb elteres
d5:     jp s7
s7:     set 7,(hl)      ;X elteres nagyobb
        res 3,(hl)
        add a,e
        jp nc,no7
        sub d
        add hl,sp
no7:    djnz s6
        jp dstack
s6:     set 6,(hl)
        res 2,(hl)
        add a,e
        jp nc,no6
        sub d
        add hl,sp
no6:    djnz s5
        jp dstack
s5:     set 5,(hl)
        res 1,(hl)
        add a,e
        jp nc,no5
        sub d
        add hl,sp
no5:    djnz s4
        jp dstack
s4:     set 4,(hl)
        res 0,(hl)
        add a,e
        jp nc,no4
        sub d
        add hl,sp
no4:    inc hl
        djnz s7
        jp dstack

s72:    set 7,(hl)      ;Y elteres nagyobb
        res 3,(hl)
        add hl,sp
        add a,e
        jp c,s60
        djnz s72
        jp dstack
s60:    djnz s61
        jp dstack
s61:    sub d
s62:    set 6,(hl)
        res 2,(hl)
        add hl,sp
        add a,e
        jp c,s50
        djnz s62
        jp dstack
s50:    djnz s51
        jp dstack
s51:    sub d
s52:    set 5,(hl)
        res 1,(hl)
        add hl,sp
        add a,e
        jp c,s40
        djnz s52
        jp dstack
s40:    djnz s41
        jp dstack
s41:    sub d
s42:    set 4,(hl)
        res 0,(hl)
        add hl,sp
        add a,e
        jp c,s70
        djnz s42
        jp dstack
s70:    djnz s71
        jp dstack
s71:    sub d
        inc hl
        jp s72
dstack: LD SP,0
        RET

lpt:    db 0-1,2,8,55,0,0,0,0
        db 255,255,0,0,0,0,0,0
        db 0-34,2,8,8
        ds 12
        db 256-128,10110010b,23,39,0,10h,0,0
        db 0,255,0,0,0,0,0,0
        db 0-35,2,8,8
        ds 12
        db 0-1,2,8,55,0,0,0,0
        db 255,255,0,0,0,0,0,0
        db 0-54,2,8,55,0,0,0,0
        db 4,4,0,0,0,0,0,0
        db 0-3,0,63,0
        ds 12
        db 0-2,0,6,63
        ds 12
        db 0-1,0,63,32
        ds 12
        db 0-53,3,8,55,0,0,0,0
        db 4,4,0,0,0,0,0,0
lend:   db 0
name:   db 9,"sinus.dat"
sugar:  db 03Ah
alfa:   db 004h
beta:   db 040h
gamma:  db 034h

        ;Small demo forgatas adatai,byte-ok:
        ; 0.   :Mennyi ideig legyen kinn (mp.) ;0ffh, ha nincs tobb
        ; 1.-2.: ???
        ; 3.   :Alfa  valtozasa
        ; 4.   :Beta  valtozasa
        ; 5.   :Gamma valtozasa
        ; 6.   :Pontok szama
        ; 7.-n.:Pontok adatai (X,Y,Z koordinatak)
        ; n.-m.:Vonalak adatai (kezdo- es vegpont szama)
        ; 0ffh :Vonalak vege



fdats:  DB   5,2,3,2,3,3,20,188,158,10,188,158,138,168,158,10
        DB   168,158,138,158,138,10,158,138,138,30,138,10,30,138,138,40
        DB   158,10,40,158,138,60,138,10,60,138,138,0,80,10,0,80
        DB   138,0,40,10,0,40,138,148,10,10,148,10,138,20,10,10
        DB   20,10,138,0,1,2,3,4,5,6,7,8,9,10,11,12
        DB   13,14,15,16,17,18,19,0,2,2,4,4,6,6,8,8
        DB   10,10,12,12,0,14,16,16,18,18,14,1,3,3,5,5
        DB   7,7,9,9,11,11,13,13,1,15,17,17,19,19,15,255
        DB   10,3,254,3,4,251,40,208,50,10,208,50,138,208,178,10
        DB   208,178,138,188,30,10,188,30,138,174,50,10,174,50,138,164
        DB   178,10,164,178,138,148,158,10,148,158,138,0,50,10,0,50
        DB   138,0,178,10,0,178,138,0,138,10,0,138,138,0,158,10
        DB   0,158,138,20,30,10,20,30,138,20,10,10,20,10,138,60
        DB   138,10,60,138,138,60,158,10,60,158,138,80,50,10,80,50
        DB   138,80,30,10,80,30,138,80,10,10,80,10,138,80,178,10
        DB   80,178,138,148,50,10,148,50,138,188,178,10,188,178,138,0
        DB   2,2,38,38,4,4,8,8,14,14,12,12,36,36,10,10
        DB   6,6,0,12,28,28,30,30,20,20,22,22,32,32,34,34
        DB   14,18,26,26,24,24,16,1,3,3,39,39,5,5,9,9
        DB   15,15,13,13,37,37,11,11,7,7,1,13,29,29,31,31
        DB   21,21,23,23,33,33,35,35,15,19,27,27,25,25,17,0
        DB   1,2,3,38,39,14,15,12,13,36,37,6,7,18,19,26
        DB   27,24,25,16,17,34,35,32,33,22,23,20,21,30,31,28
        DB   29,4,5,8,9,255,10,0,4,251,3,252,41,248,158,0
        DB   248,0,0,248,30,0,222,30,14,222,0,14,218,158,18,218
        DB   0,18,218,30,18,192,30,30,192,0,30,192,158,30,188,158
        DB   32,188,4,32,188,30,32,162,30,40,162,158,40,174,4,36
        DB   158,158,42,158,0,42,158,30,42,132,30,44,132,0,44,132
        DB   158,44,0,158,46,0,4,46,0,30,46,26,30,42,26,158
        DB   42,14,4,44,30,158,40,30,30,40,56,158,34,56,30,34
        DB   74,158,24,74,30,24,90,30,16,90,0,16,90,158,16,116
        DB   30,0,116,0,0,116,158,0,0,2,2,3,3,4,4,1
        DB   5,7,7,8,8,9,9,6,6,10,14,13,13,11,11,15
        DB   12,16,20,19,19,18,18,21,21,22,22,17,26,25,25,23
        DB   23,27,24,28,29,30,30,31,31,32,32,34,34,35,34,33
        DB   38,35,35,36,36,39,39,40,40,37,255,15,2,253,3,5
        DB   252,42,228,0,138,192,0,14,192,30,14,228,30,0,228,60
        DB   0,192,60,14,188,0,14,188,60,14,168,34,12,148,60,4
        DB   148,0,4,144,0,2,2,60,134,20,0,142,138,24,0,14
        DB   24,138,24,60,142,24,0,142,60,0,140,64,60,138,64,0
        DB   138,100,0,8,208,148,138,178,148,12,172,168,14,172,208,14
        DB   208,208,138,132,148,6,168,148,14,168,172,14,148,172,12,168
        DB   208,14,132,208,6,0,208,4,0,148,4,20,174,134,40,148
        DB   142,40,208,142,44,208,144,80,208,140,80,148,140,44,148,144
        DB   0,1,1,2,2,3,3,4,4,5,6,7,7,8,8,9
        DB   9,10,11,14,14,12,12,15,15,13,14,15,16,17,17,18
        DB   19,20,20,21,22,23,23,24,24,25,25,26,26,22,27,28
        DB   28,29,29,30,29,31,31,32,33,34,34,35,35,36,36,37
        DB   40,41,41,38,38,39,39,40,255,15,2,255,1,2,255,8
        DB   178,50,50,178,50,178,178,178,50,178,178,178,50,50,50,50
        DB   50,178,50,178,50,50,178,178,0,1,0,2,0,4,1,3
        DB   1,5,2,3,2,6,3,7,4,5,4,6,5,7,6,7
        DB   255,15,0,252,254,2,252,9,168,208,60,40,208,60,80,208
        DB   40,80,208,168,40,208,188,168,208,188,208,208,168,208,208,40
        DB   0,80,0,0,1,1,2,2,3,3,4,4,5,5,6,6
        DB   7,7,0,0,8,1,8,2,8,3,8,4,8,5,8,6
        DB   8,7,8,255,15,253,3,3,4,251,12,188,100,148,60,100
        DB   148,100,60,148,100,188,148,60,228,148,188,228,148,228,188,148
        DB   228,60,148,168,40,20,40,40,20,40,168,20,168,168,20,0
        DB   5,1,4,2,7,6,3,0,1,1,2,2,3,3,4,4
        DB   5,5,6,6,7,7,0,8,9,9,10,10,11,11,8,0
        DB   8,7,8,1,9,2,9,10,3,10,4,11,6,11,5,255
        DB   15,254,3,2,3,254,18,0,60,0,50,30,0,50,158,0
        DB   0,188,0,178,158,0,178,30,0,0,40,188,32,24,188,32
        DB   150,188,0,168,188,160,150,188,160,24,188,0,40,80,32,24
        DB   80,32,150,80,0,168,80,160,150,80,160,24,80,0,1,1
        DB   2,2,3,3,4,4,5,5,0,6,7,7,8,8,9,9
        DB   10,10,11,11,6,12,13,13,14,14,15,15,16,16,17,17
        DB   12,0,6,0,12,1,7,1,13,2,8,2,14,3,9,3
        DB   15,4,10,4,16,5,11,5,17,255,20,1,2,2,3,254
        DB   16,228,0,20,100,60,20,100,0,148,100,188,20,100,166,18
        DB   100,166,4,100,152,4,100,152,18,100,138,134,100,10,134,100
        DB   138,14,100,10,14,100,24,4,100,38,4,100,38,18,100,24
        DB   18,0,1,1,3,3,0,1,2,2,3,0,2,5,6,6
        DB   7,7,4,4,5,8,9,9,11,11,10,10,8,12,13,13
        DB   14,14,15,15,12,255,20,253,4,253,4,5,38,208,0,40
        DB   208,0,168,208,208,40,208,208,168,80,0,40,80,0,168,80
        DB   208,40,80,208,168,188,50,0,60,50,0,168,168,40,168,148
        DB   40,148,148,40,148,168,40,138,168,40,138,148,40,10,148,40
        DB   10,168,40,20,148,40,40,148,40,20,168,40,40,168,40,40
        DB   168,168,60,168,168,40,208,168,60,208,168,20,70,26,20,70
        DB   6,40,70,26,40,70,6,20,20,26,20,36,6,40,20,26
        DB   40,36,6,208,148,138,208,148,10,208,168,138,208,168,10,0
        DB   2,2,6,6,4,0,4,1,3,3,7,7,5,5,1,0
        DB   1,2,3,4,5,6,7,0,8,1,8,8,9,4,9,5
        DB   9,10,11,11,12,12,13,13,10,14,15,15,16,16,17,17
        DB   14,18,19,19,21,20,21,20,18,22,23,23,25,24,25,24
        DB   22,34,35,35,37,36,37,36,34,26,27,27,28,28,29,28
        DB   26,27,29,26,29,31,33,33,32,32,30,30,31,31,27,33
        DB   29,28,32,30,26,255,20,3,2,3,253,4,33,0,228,0
        DB   138,188,4,138,188,132,10,188,4,10,188,132,0,182,4,0
        DB   182,132,0,24,4,0,24,132,158,40,4,158,40,132,138,40
        DB   4,138,40,132,10,40,4,10,40,132,30,40,4,30,40,132
        DB   30,46,4,30,46,132,158,46,4,158,46,132,138,46,4,138
        DB   46,132,10,46,4,10,46,132,138,94,4,138,94,132,132,100
        DB   4,132,100,132,4,100,4,4,100,132,10,94,4,10,94,132
        DB   0,1,1,11,0,3,3,13,9,15,15,17,17,19,19,9
        DB   21,25,25,27,27,29,29,31,31,23,5,7,6,8,0,2
        DB   2,12,0,4,4,14,10,16,16,18,18,20,20,10,22,26
        DB   26,28,28,30,30,32,32,24,1,2,3,4,11,12,9,10
        DB   19,20,21,22,23,24,17,18,15,16,13,14,25,26,27,28
        DB   29,30,31,32,255,15,253,4,253,4,5,32,228,60,10,228
        DB   60,138,100,60,10,100,60,138,100,188,10,100,188,138,228,188
        DB   10,228,188,138,178,168,10,178,138,10,158,138,10,158,168,10
        DB   138,168,10,138,40,10,158,40,10,158,10,10,178,10,10,178
        DB   40,10,10,40,10,10,168,10,30,168,10,30,40,10,50,40
        DB   10,50,138,10,70,138,10,70,40,10,50,148,10,70,148,10
        DB   50,168,10,70,168,10,198,40,10,198,168,10,0,2,2,4
        DB   4,6,0,6,1,3,3,5,5,7,7,1,0,1,2,3
        DB   4,5,6,7,30,17,17,16,16,15,15,14,14,13,13,12
        DB   12,11,11,10,10,9,9,8,8,31,31,30,18,19,19,20
        DB   20,21,21,18,22,23,23,24,24,25,25,22,26,27,27,29
        DB   29,28,28,26,255,20,252,252,2,3,4,36,188,60,14,188
        DB   60,142,158,100,14,158,100,142,32,100,14,32,100,142,50,70
        DB   14,50,70,142,50,40,14,50,40,142,10,158,14,10,158,142
        DB   10,188,14,10,188,142,138,188,14,138,188,142,138,158,14,138
        DB   158,142,30,40,14,30,40,142,30,66,14,30,66,142,20,80
        DB   14,20,80,142,148,80,14,148,80,142,172,50,14,172,50,142
        DB   138,208,14,138,208,142,10,208,14,10,208,142,10,228,14,10
        DB   228,142,138,228,14,138,228,142,0,2,2,4,4,6,6,8
        DB   8,10,10,12,12,14,14,16,16,18,18,20,20,22,22,24
        DB   24,26,26,0,1,3,3,5,5,7,7,9,9,11,11,13
        DB   13,15,15,17,17,19,19,21,21,23,23,25,25,27,27,1
        DB   0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
        DB   16,17,18,19,20,21,22,23,24,25,26,27,28,30,30,32
        DB   32,34,34,28,29,31,31,33,33,35,35,29,28,29,30,31
        DB   32,33,34,35,255,20,2,2,3,253,4,17,168,80,40,168
        DB   80,168,40,80,40,40,80,168,0,0,0,168,208,40,168,208
        DB   168,40,208,40,40,208,168,168,80,0,0,80,40,40,80,0
        DB   168,208,0,0,208,40,40,208,0,0,80,168,0,208,168,0
        DB   2,2,7,7,5,5,0,1,3,3,8,8,6,6,1,0
        DB   1,2,3,7,8,5,6,0,8,3,5,1,7,2,6,15
        DB   13,10,16,11,12,9,14,255,20,252,3,4,3,251,40,188
        DB   0,10,188,0,0,60,0,10,60,0,0,60,188,10,60,188
        DB   0,40,198,4,40,198,0,164,198,4,164,198,0,188,188,10
        DB   188,188,0,178,152,12,30,152,12,178,162,12,30,162,12,178
        DB   170,12,30,170,12,178,178,12,30,178,12,174,186,12,30,186
        DB   12,152,192,8,20,192,8,40,158,10,48,158,10,40,166,10
        DB   48,166,10,188,20,16,188,20,0,40,20,16,40,20,0,40
        DB   80,16,40,80,0,188,80,16,188,80,0,178,70,18,16,70
        DB   18,16,30,18,178,30,18,0,2,2,4,4,6,6,8,8
        DB   10,10,0,1,3,3,5,5,7,7,9,9,11,11,1,0
        DB   1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16
        DB   17,18,19,20,21,22,23,24,25,25,27,27,26,26,24,28
        DB   30,30,32,32,34,34,28,29,31,31,33,33,35,35,29,34
        DB   35,32,33,30,31,28,29,36,37,37,38,38,39,39,36,255
        DB   30,0,0,1,2,254,26,0,0,168,0,0,40,168,20,148
        DB   168,20,20,168,148,148,168,148,20,148,40,148,148,40,20,148
        DB   168,148,148,168,20,20,40,148,20,40,20,20,168,148,20,168
        DB   20,40,20,148,40,20,20,40,148,148,40,148,20,188,24,0
        DB   152,60,0,24,60,0,60,24,0,60,152,0,24,188,0,152
        DB   188,0,188,152,0,2,6,3,7,0,2,0,6,0,10,0
        DB   14,0,16,0,12,0,8,0,4,1,3,1,7,1,11,1
        DB   15,1,17,1,13,1,9,1,5,6,10,10,14,14,16,16
        DB   12,12,8,8,4,4,2,7,11,11,15,15,17,17,13,13
        DB   9,9,5,5,3,18,19,19,20,20,21,21,22,22,23,23
        DB   24,24,25,25,18,2,18,6,19,10,20,14,21,16,22,12
        DB   23,8,24,4,25,3,18,7,19,11,20,15,21,17,22,13
        DB   23,9,24,5,25,255,30,0,0,4,4,0,20,208,100,168
        DB   100,100,164,100,208,160,208,208,156,208,80,152,80,80,148,80
        DB   188,144,188,188,140,188,60,136,60,60,132,60,168,0,168,168
        DB   4,168,40,8,40,40,12,40,148,16,148,148,20,148,20,24
        DB   20,20,28,20,0,32,0,0,36,0,1,1,2,2,3,3
        DB   4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11
        DB   12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,255
        DB   30,0,0,0,0,5,34,228,40,0,188,40,0,188,26,0
        DB   214,26,0,214,6,0,198,6,0,198,134,0,214,134,0,214
        DB   154,0,188,154,0,188,168,0,228,168,0,178,40,0,158,40
        DB   0,0,144,0,0,40,0,14,40,0,14,168,0,134,168,0
        DB   164,16,0,164,168,0,178,168,0,26,40,0,68,40,0,80
        DB   20,0,80,158,0,72,168,0,26,168,0,46,20,0,60,20
        DB   0,64,12,0,64,140,0,60,148,0,46,148,0,0,1,1
        DB   2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9
        DB   10,10,11,11,0,12,13,13,14,14,15,15,16,16,17,17
        DB   18,18,19,19,20,20,21,21,12,22,23,23,24,24,25,25
        DB   26,26,27,27,22,28,29,29,30,30,31,31,32,32,33,33
        DB   28,255,255

stabl:  DB 000h,003h,006h,009h,00Ch,00Fh,012h,015h,018h,01Bh,01Eh,021h,024h,027h,02Ah,02Dh
        DB 030h,033h,036h,039h,03Bh,03Eh,041h,043h,046h,049h,04Bh,04Eh,050h,052h,055h,057h
        DB 059h,05Bh,05Eh,060h,062h,064h,066h,067h,069h,06Bh,06Ch,06Eh,070h,071h,072h,074h
        DB 075h,076h,077h,078h,079h,07Ah,07Bh,07Bh,07Ch,07Dh,07Dh,07Eh,07Eh,07Eh,07Eh,07Eh
        DB 07Fh,07Eh,07Eh,07Eh,07Eh,07Eh,07Dh,07Dh,07Ch,07Bh,07Bh,07Ah,079h,078h,077h,076h
        DB 075h,074h,072h,071h,070h,06Eh,06Ch,06Bh,069h,067h,066h,064h,062h,060h,05Eh,05Bh
        DB 059h,057h,055h,052h,050h,04Eh,04Bh,049h,046h,043h,041h,03Eh,03Bh,039h,036h,033h
        DB 030h,02Dh,02Ah,027h,024h,021h,01Eh,01Bh,018h,015h,012h,00Fh,00Ch,009h,006h,003h
        DB 000h,084h,087h,08Ah,08Dh,090h,093h,096h,099h,09Ch,09Fh,0A2h,0A5h,0A8h,0ABh,0AEh
        DB 0B1h,0B4h,0B7h,0BAh,0BCh,0BFh,0C2h,0C4h,0C7h,0CAh,0CCh,0CFh,0D1h,0D3h,0D6h,0D8h
        DB 0DAh,0DCh,0DFh,0E1h,0E3h,0E5h,0E7h,0E8h,0EAh,0ECh,0EDh,0EFh,0F1h,0F2h,0F3h,0F5h
        DB 0F6h,0F7h,0F8h,0F9h,0FAh,0FBh,0FCh,0FCh,0FDh,0FEh,0FEh,0FFh,0FFh,0FFh,0FFh,0FFh
        DB 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FEh,0FEh,0FDh,0FCh,0FCh,0FBh,0FAh,0F9h,0F8h,0F7h
        DB 0F6h,0F5h,0F3h,0F2h,0F1h,0EFh,0EDh,0ECh,0EAh,0E8h,0E7h,0E5h,0E3h,0E1h,0DFh,0DCh
        DB 0DAh,0D8h,0D6h,0D3h,0D1h,0CFh,0CCh,0CAh,0C7h,0C4h,0C2h,0BFh,0BCh,0BAh,0B7h,0B4h
        DB 0B1h,0AEh,0ABh,0A8h,0A5h,0A2h,09Fh,09Ch,099h,096h,093h,090h,08Dh,08Ah,087h,084h
        DB 081h,003h,006h,009h,00Ch,00Fh,012h,015h,018h,01Bh,01Eh,021h,024h,027h,02Ah,02Dh
        DB 030h,033h,036h,039h,03Bh,03Eh,041h,043h,046h,049h,04Bh,04Eh,050h,052h,055h,057h
        DB 059h,05Bh,05Eh,060h,062h,064h,066h,067h,069h,06Bh,06Ch,06Eh,070h,071h,072h,074h
        DB 075h,076h,077h,078h,079h,07Ah,07Bh,07Bh,07Ch,07Dh,07Dh,07Eh,07Eh,07Eh,07Eh,07Eh
        DB 07Fh,07Eh,07Eh,07Eh,07Eh,07Eh,07Dh,07Dh,07Ch,07Bh,07Bh,07Ah,079h,078h,077h,076h
        DB 075h,074h,072h,071h,070h,06Eh,06Ch,06Bh,069h,067h,066h,064h,062h,060h,05Eh,05Bh
        DB 059h,057h,055h,052h,050h,04Eh,04Bh,049h,046h,043h,041h,03Eh,03Bh,039h,036h,033h
        DB 030h,02Dh,02Ah,027h,024h,021h,01Eh,01Bh,018h,015h,012h,00Fh,00Ch,009h,006h,003h
        DB 000h

lastaddr:

k2:     ds 200h
